function DecodeTemplateFieldService(templateManager) {
	var handleCustomViewTemplate = {};

	this.registerViewTemplate = function(template, viewTemplate) {
		if (handleCustomViewTemplate.hasOwnProperty(template)) {
			throw new Error("There is already a view template registered for this template.");
		}
		handleCustomViewTemplate[template] = viewTemplate;
	};

	this.decodeViewTemplate = function(field, template) {
		template = template || field.template;
		if (handleCustomViewTemplate.hasOwnProperty(field.template)) {
			template = handleCustomViewTemplate[field.template];
		}
		
		return templateManager.getTemplateURL(template);
	};

}